/*
 * Client.java
 *
 * Created on February 15, 2007, 4:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.sun.appserver.ee.tests.client;

import javax.naming.InitialContext;
import java.io.*;
import com.sun.appserver.ee.tests.ejb.stateful.*;
import com.sun.appserver.ee.tests.ejb.stateless.*;
import enterprise.lottery_annotation_ejb_stateless.*;
import enterprise.lottery_annotation_ejb_stateful.*;
import com.sun.dft.glassfish.ipc.api.CallbackClient;
import java.util.List;

/**
 *
 * @author Gopal Jorapur
 */
public class ClientDynamicClusterAddInstance {
    
    private InitialContext ic = null;
    private SFSB1Remote sfsb1Remote = null;
    private SFSB2Remote sfsb2Remote = null;
    private SFSB3Remote sfsb3Remote = null;
    private SFSB4Remote sfsb4Remote = null;
    private SFSB5Remote sfsb5Remote = null;
    
    private SLSB1Remote slsb1Remote = null;
    private SLSB2Remote slsb2Remote = null;
    private SLSB3Remote slsb3Remote = null;
    private SLSB4Remote slsb4Remote = null;
    private SLSB5Remote slsb5Remote = null;
    
    /** Creates a new instance of Client */
    public ClientDynamicClusterAddInstance() {
        try{
            ic = new InitialContext();
            out("Created ic");
        }catch(Exception ex){
            out("Error in creating the ic");
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String choice = "FailoverLB";
        if((args != null) && (args.length>0)){
            choice = args[0];
        }
        ClientDynamicClusterAddInstance client = new ClientDynamicClusterAddInstance();
        if("FailoverLB".equalsIgnoreCase(choice)){
            client.multipleFOMain();
           
        }else if("FOBeanCalls".equalsIgnoreCase(choice)){
            client.runFOBetweenBeanCalls();

        }else if("Lottery".equalsIgnoreCase(choice)){
            client.runTest();
            waitForEnter();
            client.callLotteryEJB();
        }else if("StickyFOWithRestartAndNewIC".equalsIgnoreCase(choice)){
            client.stickyFOWithRestartAndNewIC();
        }else if("iiopCRNP".equalsIgnoreCase(choice)){
            client.iiopCRNP(Integer.valueOf(args[1]));
        }else if("MultipleFO".equalsIgnoreCase(choice)){
            client.runMultipleFOTest();


        }else if("sticky".equalsIgnoreCase(choice)){
            client.runTest();
            waitForEnter();
            client.runTest3();
        }
    }


    private void runFOBetweenBeanCalls(){

        String instanceName = null;
        runTest();
        try{
        instanceName = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.sayHello");
        CallbackClient.killInstance(instanceName);

        //Adding new instances to the cluster
        List<String> instanceNames = CallbackClient.getInstancesInCluster();

        int lastInstance = instanceNames.size() - 1;
        int lastButOne = instanceNames.size() - 2;

        CallbackClient.createInstance(instanceNames.get(lastButOne),lastButOne,"100");
        CallbackClient.createInstance(instanceNames.get(lastInstance),lastInstance,"100");
        CallbackClient.startInstance(instanceNames.get(lastButOne));
        CallbackClient.startInstance(instanceNames.get(lastInstance));

        CallbackClient.startInstance(instanceName);
        Thread.sleep(10000);

        String name = null;
        name = sfsb1Remote.getName();
        out("Receive the name "+ name);

        name = sfsb2Remote.getName();
        out("Receive the name "+ name);

        instanceName = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.getName");
        CallbackClient.killInstance(instanceName);
        CallbackClient.startInstance(instanceName);
        Thread.sleep(10000);


        name = sfsb3Remote.getName();
        out("Receive the name "+ name);

        name = sfsb4Remote.getName();
        out("Receive the name "+ name);

        name = sfsb5Remote.getName();
        out("Receive the name "+ name);
        }catch(Exception ex){
            ex.printStackTrace();
        }

        int Total = 0 , getNameCount = 0, getNameCount1 = 0;

            try{
            List<String> instanceNames = CallbackClient.getInstancesInCluster();
            int[] count = new int[10];
            for (int i =0; i < instanceNames.size(); i++) {
                System.out.println("Instance Name: " + instanceNames.get(i));
                count[i] = CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHello()");
                System.out.println("Instance " + instanceNames.get(i) + " handled " + count[i] + " requests");
                Total = Total + count[i];
                getNameCount = getNameCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "getName()");
                }
                if((Total==10) && (getNameCount == 5)){
                System.out.println("PASS");
                } else {
                System.out.println("FAIL");
                }

            }catch(Exception ex){
                out("Error in creating the ic");
                ex.printStackTrace();
            }

    }

    private void runMultipleFOTest(){

        String instanceName = null;
        runTest();
        try{
        instanceName = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.sayHello");
        CallbackClient.killInstance(instanceName);
        
        //Adding new instances to the cluster
         List<String> instanceNames = CallbackClient.getInstancesInCluster();

        int lastInstance = instanceNames.size() - 1;
        int lastButOne = instanceNames.size() - 2;

        CallbackClient.createInstance(instanceNames.get(lastButOne),lastButOne,"100");
        CallbackClient.createInstance(instanceNames.get(lastInstance),lastInstance,"100");
        CallbackClient.startInstance(instanceNames.get(lastButOne));
        CallbackClient.startInstance(instanceNames.get(lastInstance));

        Thread.sleep(10000);

        }catch(Exception ex){
                out("Error in CallbackClient");
                ex.printStackTrace();
        }
        runTest2();

        int Total = 0 , getNameCount = 0, getNameCount1 = 0, getNameCount2 = 0;

            try{
            List<String> instanceNames = CallbackClient.getInstancesInCluster();
            int[] count = new int[10];
            for (int i =0; i < instanceNames.size(); i++) {
                System.out.println("Instance Name: " + instanceNames.get(i));
                count[i] = CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHello ");
                System.out.println("Instance " + instanceNames.get(i) + " handled " + count[i] + " requests");
                Total = Total + count[i];

                    getNameCount = getNameCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "getName()");

                }

                if((Total==10) && (getNameCount == 5) ){
                System.out.println("PASS");
                } else {
                System.out.println("FAIL");
                }
            }catch(Exception ex){
                out("Error in creating the ic");
                ex.printStackTrace();
            }

    }

    private void multipleFOMain(){


           String instanceName = null;

          try{
            runTest();

          instanceName = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.sayHello");
          CallbackClient.killInstance(instanceName);

        //Adding new instances to the cluster
         List<String> instanceNames = CallbackClient.getInstancesInCluster();

        int lastInstance = instanceNames.size() - 1;
        int lastButOne = instanceNames.size() - 2;

        CallbackClient.createInstance(instanceNames.get(lastButOne),lastButOne,"100");
        CallbackClient.createInstance(instanceNames.get(lastInstance),lastInstance,"100");
        CallbackClient.startInstance(instanceNames.get(lastButOne));
        CallbackClient.startInstance(instanceNames.get(lastInstance));

        Thread.sleep(10000);


            Thread.sleep(10000);


            multipleFO();
            }catch(Exception ex){
                out("Error in CallbackClient");
                ex.printStackTrace();
            }


    }
    
    private void multipleFO(){        
        for(int i = 0 ; i < 100; i++){
            try{
                ic=null;
                ic = new InitialContext();
                out("Created ic");
                runTest();
            }catch(Exception ex){
                out("Error in creating the ic");
                ex.printStackTrace();
            }
        }

       int Total = 0;

            String failoverInstance ;
            try{
            List<String> instanceNames = CallbackClient.getInstancesInCluster();
            int[] count = new int[10];
            for (int i =0; i < instanceNames.size(); i++) {
                System.out.println("Instance Name: " + instanceNames.get(i));
                count[i] = CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHello ");
                System.out.println("Instance " + instanceNames.get(i) + " handled " + count[i] + " requests");
                Total = Total + count[i];
                if(count[i]<=0){
                             System.out.println("FAIL");
                }

           }
            }catch(Exception ex){
                out("Error in creating the ic");
                ex.printStackTrace();
            }

           if(Total==1010){
           System.out.println("PASS");
           } else {
           System.out.println("FAIL");
           }
    }
    
    private void runTest(){
        out("Called runTest");
        try{
            sfsb1Remote = (SFSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB1Remote");
            sfsb1Remote.setName("SFSB1");
            sfsb1Remote.sayHello();
            out("SFSB1 done");
            
            sfsb2Remote = (SFSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB2Remote");
            sfsb2Remote.setName("SFSB2");
            sfsb2Remote.sayHello();
            out("SFSB2 done");
            
            sfsb3Remote = (SFSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB3Remote");
            sfsb3Remote.setName("SFSB3");
            sfsb3Remote.sayHello();
            out("SFSB3 done");
            
            sfsb4Remote = (SFSB4Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB4Remote");
            sfsb4Remote.setName("SFSB4");
            sfsb4Remote.sayHello();
            out("SFSB4 done");
            
            sfsb5Remote = (SFSB5Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB5Remote");
            sfsb5Remote.setName("SFSB5");
            sfsb5Remote.sayHello();
            out("SFSB5 done");
            
            slsb1Remote = (SLSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB1Remote");
            slsb1Remote.sayHello();
            out("SLSB1 done");
            
            slsb2Remote = (SLSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB2Remote");
            slsb2Remote.sayHello();
            out("SLSB2 done");
            
            slsb3Remote = (SLSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB3Remote");
            slsb3Remote.sayHello();
            out("SLSB3 done");
            
            slsb4Remote = (SLSB4Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB4Remote");
            slsb4Remote.sayHello();
            out("SLSB4 done");
            
            slsb5Remote = (SLSB5Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB5Remote");
            slsb5Remote.sayHello();
            out("SLSB5 done");
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void runTest3(){
        try{
            out("Called runtest2");
            sfsb1Remote.sayHello();
            out("SFSB1 done");
            
            sfsb2Remote.sayHello();
            out("SFSB2 done");
            
            sfsb3Remote.sayHello();
            out("SFSB3 done");
            
            sfsb4Remote.sayHello();
            out("SFSB4 done");
            
            sfsb5Remote.sayHello();
            out("SFSB5 done");
            
            waitForEnter();            

            String name = null;
            name = sfsb1Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb2Remote.getName();
            out("Receive the name "+ name);     
            
            name = sfsb3Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb4Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb5Remote.getName();
            out("Receive the name "+ name);
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void runTest2(){
        try{
            out("Called runtest2");
            String name = null;
            name = sfsb1Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb2Remote.getName();
            out("Receive the name "+ name);

            String instanceName = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.getName");
            CallbackClient.killInstance(instanceName);
            
            name = sfsb3Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb4Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb5Remote.getName();
            out("Receive the name "+ name);
        }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void callLotteryEJB(){
        for(int j = 0 ; j < 100; j++){
            
            try {
                Lottery lottery1 =
                        (Lottery) ic.lookup("enterprise.lottery_annotation_ejb_stateful.Lottery");
                lottery1.setName("Super Stinker");
                Dice dice1;
                for(int i=0; i<6; i++) {
                    dice1 =
                            (Dice) ic.lookup("enterprise.lottery_annotation_ejb_stateless.Dice");
                    lottery1.select(dice1.play());
                }
                
                String lotteryName = lottery1.getName();
                String lotteryNumber = lottery1.getNumber();
                String lotteryDate = lottery1.getDate();
                String results = "Your" + " " + lotteryName + " " +
                        "quick pick, played on" + " " + lotteryDate +
                        " " + "is" + " " + lotteryNumber;
                System.out.println(results);
                lottery1=null;
                dice1=null;
            } catch(Exception e) {
                System.out.println("Exception: " + e);
                e.printStackTrace();
            }
        }
    }
    
    public void stickyFOWithRestartAndNewIC(){
        try{
            sfsb1Remote = (SFSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB1Remote");
            sfsb1Remote.setName("blah");
            
            sfsb2Remote = (SFSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB2Remote");
            sfsb2Remote.setName("blah");
            
            sfsb3Remote = (SFSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB3Remote");
            sfsb3Remote.setName("blah");
            
            slsb1Remote = (SLSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB1Remote");
            slsb1Remote.sayHello();
            out("SLSB1 done");
            
            slsb2Remote = (SLSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB2Remote");
            slsb2Remote.sayHello();
            out("SLSB2 done");
            
            slsb3Remote = (SLSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB3Remote");
            slsb3Remote.sayHello();
            out("SLSB3 done");
            
            //Wait for first instance to be killed.
            String instance = CallbackClient.findInstanceWithMessageInLog("SLSB1Bean.sayHello");
            System.out.print("killing instance - " + instance);
            CallbackClient.killInstance(instance);

             List<String> instanceNames = CallbackClient.getInstancesInCluster();

            int lastInstance = instanceNames.size() - 1;
            int lastButOne = instanceNames.size() - 2;

            CallbackClient.createInstance(instanceNames.get(lastButOne),lastButOne,"100");
            CallbackClient.createInstance(instanceNames.get(lastInstance),lastInstance,"100");
            CallbackClient.startInstance(instanceNames.get(lastButOne));
            CallbackClient.startInstance(instanceNames.get(lastInstance));
            Thread.sleep(10000);

            
            
            sfsb1Remote.setName("SFSB1");
            sfsb1Remote.sayHelloAgain();
            out("SFSB1 done");
            
            sfsb2Remote.setName("SFSB2");
            sfsb2Remote.sayHelloAgain();
            out("SFSB2 done");
            
            //Wait for the first instance to be restarted;
            CallbackClient.startInstance(instance);
            
            sfsb3Remote.setName("SFSB3");
            sfsb3Remote.sayHelloAgain();
            out("SFSB3 done");
            
            String name = null;
            name = sfsb1Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb2Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb3Remote.getName();
            out("Receive the name "+ name);
            
            InitialContext ic1 = null;
            
            try{
                ic1 = new InitialContext();
                out("Created ic1");
            }catch(Exception ex1){
                out("Error in creating the ic1");
                ex1.printStackTrace();
            }
            
            sfsb4Remote = (SFSB4Remote)ic1.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB4Remote");
            sfsb4Remote.setName("SFSB4");
            sfsb4Remote.sayHello();
            out("SFSB4 done");
            
            sfsb5Remote = (SFSB5Remote)ic1.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB5Remote");
            sfsb5Remote.setName("SFSB5");
            sfsb5Remote.sayHello();
            out("SFSB5 done");
            
            slsb4Remote = (SLSB4Remote)ic1.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB4Remote");
            slsb4Remote.sayHello();
            out("SLSB4 done");
            
            slsb5Remote = (SLSB5Remote)ic1.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB5Remote");
            slsb5Remote.sayHello();
            out("SLSB5 done");

            /* Reporting the results here */

             int Total = 0, sayHelloAgainCount = 0, getNameCount = 0;

            String failoverInstance ;

            instanceNames = CallbackClient.getInstancesInCluster();
            int[] count = new int[10] ;


            for (int i =0; i < instanceNames.size(); i++) {
                System.out.println("Instance Name: " + instanceNames.get(i));
                count[i] = CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHello ");
                System.out.println("Instance " + instanceNames.get(i) + " handled " + count[i] + " requests");
                Total = Total + count[i];
                    sayHelloAgainCount = sayHelloAgainCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHelloAgain()");
                    System.out.println("Instance " + instanceNames.get(i) + " handled sayHelloAgain " + sayHelloAgainCount + " requests");

                    failoverInstance = instanceNames.get(i);
                    getNameCount = getNameCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "getName()");
                    System.out.println("Instance " + instanceNames.get(i) + " handled getName " + getNameCount + " requests");



           }

           if((Total==7) && (sayHelloAgainCount==3) && (getNameCount==3) ){
           System.out.println("PASS");
           } else {
           System.out.println("FAIL");
           }


           }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    private void iiopCRNP(int depletion){
        out("Called iiopCRNP");
        try{
            sfsb1Remote = (SFSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB1Remote");
            sfsb1Remote.setName("SFSB1");
            sfsb1Remote.sayHello();
            out("SFSB1 done");
            
            sfsb2Remote = (SFSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB2Remote");
            sfsb2Remote.setName("SFSB2");
            sfsb2Remote.sayHello();
            out("SFSB2 done");
            
            sfsb3Remote = (SFSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB3Remote");
            sfsb3Remote.setName("SFSB3");
            sfsb3Remote.sayHello();
            out("SFSB3 done");
            
            sfsb4Remote = (SFSB4Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB4Remote");
            sfsb4Remote.setName("SFSB4");
            sfsb4Remote.sayHello();
            out("SFSB4 done");
            
            sfsb5Remote = (SFSB5Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateful.SFSB5Remote");
            sfsb5Remote.setName("SFSB5");
            sfsb5Remote.sayHello();
            out("SFSB5 done");
            
            slsb1Remote = (SLSB1Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB1Remote");
            slsb1Remote.sayHello();
            out("SLSB1 done");
            
            slsb2Remote = (SLSB2Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB2Remote");
            slsb2Remote.sayHello();
            out("SLSB2 done");
            
            slsb3Remote = (SLSB3Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB3Remote");
            slsb3Remote.sayHello();
            out("SLSB3 done");
            
            slsb4Remote = (SLSB4Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB4Remote");
            slsb4Remote.sayHello();
            out("SLSB4 done");
            
            slsb5Remote = (SLSB5Remote)ic.lookup("com.sun.appserver.ee.tests.ejb.stateless.SLSB5Remote");
            slsb5Remote.sayHello();
            out("SLSB5 done");
            
            //kill instance that got the request.

            //Wait for first instance to be killed.
            String firstInstance = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.sayHello");
            System.out.print("killing instance - " + firstInstance);
            CallbackClient.killInstance(firstInstance);

            // Time for GMS failure detection.
            Thread.sleep(10000);
            
            String name = null;
            name = sfsb1Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb2Remote.getName();
            out("Receive the name "+ name);

            //kill instance that got the request.

            //Wait for second instance to be killed.
            String instance = CallbackClient.findInstanceWithMessageInLog("SFSB1Bean.getName");
            System.out.print("killing instance - " + instance);
            CallbackClient.killInstance(instance);
            if(depletion == 1){
                            CallbackClient.startInstance(firstInstance);
            }

            // Time for GMS failure detection.
            Thread.sleep(10000);
            
            name = sfsb3Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb4Remote.getName();
            out("Receive the name "+ name);
            
            name = sfsb5Remote.getName();
            out("Receive the name "+ name);
            
             //kill the last instance. start the first instance.
            instance = CallbackClient.findInstanceWithMessageInLog("SFSB3Bean.getName");
            System.out.print("killing instance - " + instance);
            CallbackClient.killInstance(instance);

            if(depletion == 0){
            CallbackClient.startInstance(firstInstance);
            }

            // Time for GMS failure detection.
            Thread.sleep(10000);

            sfsb1Remote.sayHelloAgain();
            name = null;
            
            slsb1Remote.sayHelloAgain();
            out("SLSB1 done");

            // Reporting the results here

             int Total = 0 , getNameCount = 0, getNameCount1 = 0, getNameCount2 = 0, getSayHelloAgainCount = 0;

            List<String> instanceNames = CallbackClient.getInstancesInCluster();
            int[] count = new int[10];
            for (int i =0; i < instanceNames.size(); i++) {
                System.out.println("Instance Name: " + instanceNames.get(i));
                count[i] = CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHello ");
                System.out.println("Instance " + instanceNames.get(i) + " handled " + count[i] + " requests");
                Total = Total + count[i];

                    getNameCount = getNameCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "getName()");
                    getSayHelloAgainCount = getSayHelloAgainCount + CallbackClient.findInInstanceServerLog(instanceNames.get(i), "sayHelloAgain ");
                }

                if((Total==10) && (getNameCount == 5) && (getSayHelloAgainCount == 2)){
                System.out.println("PASS");
                } else {
                System.out.println("FAIL");
                }

            }catch(Exception ex){
            ex.printStackTrace();
        }
    }
    
    private void out(String msg){
        System.out.println(msg);
    }
    
    private  static void waitForEnter(){
        try{
            System.out.println("Press <Enter> to continue ...");
            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            reader.readLine();
        } catch(Exception e){
            System.out.println("Exception while waiting for <Enter>:"+e.toString());
        }
    }
    
}
